package com.example.ricca.calcolatriceandroid;

/**
 * Created by ricca on 19/05/15.
 */
public class Calcolatrice {


    public enum Operazione {
        SOMMA,PRODOTTO,SOTTRAZIONE,DIVISIONE,UGUALE
    }

    private double display=0;
    private double risultato=0;
    private Operazione operazione=Operazione.SOMMA;
    private boolean eseguitaOperazione = false;

    public String dammiDisplay()
    {
        return ""+display;
    }

    private void verificaSePrecedenteEraOperazione() {
        if(eseguitaOperazione)
        {
            display=0;
            eseguitaOperazione = false;
        }
    }

    public void premiZero()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
    }

    public void premiUno()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=1;
    }

    public void premiDue()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=2;
    }

    public void premiTre()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=3;
    }

    public void premiQuattro()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=4;
    }

    public void premiCinque()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=5;
    }

    public void premiSei()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=6;
    }

    public void premiSette()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=7;
    }

    public void premiOtto()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=8;
    }

    public void premiNove()
    {
        verificaSePrecedenteEraOperazione();
        aumentaDiUnaDecina();
        display+=9;
    }

    public void premiUguale()
    {
        eseguiOperazione();
        operazione=Operazione.UGUALE;
//		risultato=0;
    }

    private void eseguiOperazione() {
        switch (operazione) {
            case SOMMA:
                risultato+=display;
                break;
            case PRODOTTO:
                risultato*=display;
                break;
            case SOTTRAZIONE:
                risultato-=display;
                break;
            case DIVISIONE:
                risultato/=display;
                break;
            case UGUALE:
                return;
        }
        display=risultato;
        eseguitaOperazione=true;
    }

    public void premiSomma()
    {
        eseguiOperazione();
        operazione=Operazione.SOMMA;
    }

    public void premiProdotto()
    {
        eseguiOperazione();
        operazione=Operazione.PRODOTTO;
    }

    public void premiSottrazione()
    {
        eseguiOperazione();
        operazione=Operazione.SOTTRAZIONE;
    }

    public void premiDivisione()
    {
        eseguiOperazione();
        operazione=Operazione.DIVISIONE;
    }


    public void premiCancella()
    {
        risultato=0;
        display=0;
        operazione=Operazione.SOMMA;
        eseguitaOperazione = false;
    }

    private void aumentaDiUnaDecina() {
        display*=10;
    }
}
